#include "RSA_my.h"

void unpack_lic_code(unsigned char *out, const unsigned char* const a1_EAX)
{
        int processed_lic_code[WORDS]; // [esp+4h] [ebp-BCh]
        int modulo[WORDS]; // [esp+24h] [ebp-9Ch]
        int power[WORDS]; // [esp+44h] [ebp-7Ch]
        unsigned int v18[WORDS]; // [esp+64h] [ebp-5Ch]
        //unsigned char v18[100]; // [esp+64h] [ebp-5Ch]
        //unsigned char a2a[100+1]; // [esp+84h] [ebp-3Ch]

        const unsigned char* const lic_code_maybe_with_dashes=a1_EAX;

        func_464FF0_ascii_code_to_buf(processed_lic_code, (char*)lic_code_maybe_with_dashes);

	// AKA $d$
        func_464FF0_ascii_code_to_buf(power, RSA_D);

        func_464FF0_ascii_code_to_buf(modulo, RSA_modulo);

	// x, out, power, modulo
        powermod(processed_lic_code, v18, power, modulo);
        get_bytes_from_bignum(v18, out, 70);
}

void unpack_lic_code_hex(unsigned char *out, const unsigned char* const a1_EAX)
{
        unsigned char tmp[150];
        unpack_lic_code(tmp, a1_EAX);
	const char *hex="0123456789abcdef";
	for (int i=70; ; i--)
	{
		//printf ("%x\n", a2a[i]);
		*out=hex[(tmp[i]>>4)&0xf];
		out++;
		*out=hex[tmp[i]&0xf];
		out++;
		if (i==0)
			break;
	};
	*out=0;
}
